//; IDEDOS Definitions - for external applications

//	defc	ide_devs=$e42e	; number of IDE devices

#include <sys/types.h>

//Partition types
//should be u8_t !!!
enum ptype
 {	ptype_unused,
	ptype_system,
	ptype_swap,
	ptype_p3dos,
	ptype_cpm22,
	ptype_file,
	ptype_movie=0x0F,
	ptype_fat16,
	ptype_uzi=0x20,
	ptype_trdos=0x30,
	ptype_record,
	ptype_vdt,
	ptype_bad=0xFE,
	ptype_free
 };

struct sh_t
 {//Swap handle additional structure
	u8_t	sh_size;
	u16_t	sh_curb;
	u16_t	sh_maxb;
 };

struct vp_t
 {//Virtual diskimage additional structure
	u8_t	vp_first; //sectors to skip, 0 when starts at sector 1
	u16_t	vp_cyls;  //e.g. 80
	u8_t	vp_hds;   //e.g.  2
	u8_t	vp_spt;   //e.g.  9
 };

union rsvd_t
 {
	u8_t		rsvd[5];
 	struct sh_t	swap;
 	struct vp_t	img;
 };

struct ph_t
 {//Partition handle structure
	u8_t	ph_type; //ptype ???
	u16_t	ph_scyl;
	u8_t	ph_shd;
	u16_t	ph_ecyl;
	u8_t	ph_ehd;
	u32_t	ph_secs;	//highest logical sector number
  union rsvd_t	ph_rsvd;
//	u8_t	ph_unit;
//	u16_t	ph_num;
 };

struct unit_t
 {//information about the hard disk itself:
	u16_t	un_cyls;	//Number of cylinders	0..65535
	u8_t	un_hds;		//Number of heads 		0..15
	u8_t	un_spt;		//Sectors per track		0..255
	u16_t	un_spc;		//Sectors per cylinder		=un_spt*un_hds
	u16_t	un_part;	//Max partition number		0..65535
//	u16_t	un_p0;		//Pointer to system partition handle
 };


struct sinf_t
 {//System partition info section structure
	struct	unit_t	sinf_unit;
	u8_t	sinf_edcols;
	u8_t	sinf_bascols;
	u8_t	sinf_physunmap[3];
	u8_t	sinf_physmap[3];
	u8_t	sinf_defdrv;
 };

struct xdpb_t
 {//Definition of XDPB
	u16_t	lspt;
	u8_t	bsh;
	u8_t	blm;
	u8_t	exm;
	u16_t	dsm;
	u16_t	drm;
	u8_t	al0;
	u8_t	al1;
	u16_t	cks;
	u16_t	off;
	u8_t	psh;
	u8_t	phm;
	u8_t	sdn;
	u8_t	tps;
	u8_t	pspt;
	u8_t	fsn;
	u16_t	pss;
	u8_t	rwgap;
	u8_t	fgap;
	u8_t	mfm;
	u8_t	auto;
 };

struct p3inf_t
 {//+3DOS partition info section structure
	u8_t	p3inf_xdpb[28];
	u8_t	p3inf_map;
 };

union pi_t
 {
	u8_t		info[32];
	struct sinf_t	sinf;
	struct p3inf_t	p3inf;
	struct xdpb_t	xdpb;
 };

typedef union 
 {//Partition entry structure
  u8_t	part_data[64];
  struct
   {
		u8_t	part_name[16];
	struct	ph_t	part_sysinfo; //16
	union	pi_t	part_info;
   };
 } part_t;


/**** not usable at this moment
; Calls

defvars $0056 { ide_stream_open		ds.p	1
		ide_stream_close	ds.p	1
		ide_stream_in		ds.p	1
		ide_stream_out		ds.p	1
		ide_stream_ptr		ds.p	1
	}

defvars $00a0 { ide_version		ds.p	1
                ide_interface		ds.p	1
                ide_init		ds.p	1
                ide_drive		ds.p	1
                ide_sector_read		ds.p	1
                ide_sector_write	ds.p	1
                ide_format		ds.p	1
                ide_partition_find	ds.p	1
                ide_partition_new	ds.p	1
                ide_partition_init	ds.p	1
                ide_partition_erase	ds.p	1
                ide_partition_rename	ds.p	1
                ide_partition_read	ds.p	1
                ide_partition_write	ds.p	1
		ide_partition_winfo	ds.p	1
                ide_partition_open	ds.p	1
                ide_partition_close	ds.p	1
		ide_partition_getinfo	ds.p	1
		ide_partition_setinfo	ds.p	1
                ide_swap_open		ds.p	1
                ide_swap_close		ds.p	1
                ide_swap_out		ds.p	1
                ide_swap_in		ds.p	1
                ide_swap_ex		ds.p	1
                ide_swap_pos		ds.p	1
                ide_swap_move		ds.p	1
		ide_swap_resize		ds.p	1
                ide_dos_map		ds.p	1
                ide_dos_unmap		ds.p	1
		ide_dos_mapping		ds.p	1
		ide_dos_unpermanent	ds.p	1
		ide_snapload		ds.p	1
        }

; Error codes

defgroup {      rc_invpartition=56,
		rc_partexist,
		rc_notimp,
		rc_partopen,
		rc_nohandle,
		rc_notswap,
		rc_mapped,
		rc_noxdpb,
                rc_noswap,
		rc_invdevice
        }
*/

